SystemOrganization addCategory: #'Grease-Squeak-Core'!

GRPharoPlatform subclass: #GRSqueakPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Squeak-Core'!

!GRSqueakPlatform methodsFor: 'file library' stamp: 'JohnMcKeon 12/26/2014 19:35'!
deleteFile: aFileName inFolder: aPathString 
	(FileDirectory on: aPathString)
		deleteFileNamed: aFileName! !

!GRSqueakPlatform methodsFor: 'file library' stamp: 'JohnMcKeon 12/31/2014 09:23'!
directoriesIn: aPathString
	"Return a collection of absolute paths for all the files (no directories) in the directory given by aPathString
	must not include file names that start with ."
	| directory |
	directory := FileDirectory default directoryNamed: aPathString.
	^ (directory directoryNames
		reject: [ :each | each first = $. ])
		collect: [ :each | directory fullNameFor: each ]! !

!GRSqueakPlatform methodsFor: 'private' stamp: 'JohnMcKeon 12/26/2014 19:36'!
doSilently: aBlock
	^SystemChangeNotifier uniqueInstance doSilently: aBlock! !

!GRSqueakPlatform methodsFor: 'file library' stamp: 'JohnMcKeon 12/31/2014 09:32'!
ensureExistenceOfFolder: aString
	^FileDirectory default assureExistenceOfPath: aString! !

!GRSqueakPlatform methodsFor: 'file library' stamp: 'JohnMcKeon 12/31/2014 09:35'!
fileExists: aString
	^FileDirectory default fileExists: aString! !

!GRSqueakPlatform methodsFor: 'file library' stamp: 'JohnMcKeon 12/26/2014 19:35'!
filesIn: aPathString
	"Return a collection of absolute paths for all the files (no directories) in the directory given by aPathString
	must not include file names that start with ."
	| directory |
	directory := FileDirectory default directoryNamed: aPathString.
	^ (directory fileNames
		reject: [ :each | each first = $. ])
		collect: [ :each | directory fullNameFor: each ]! !

!GRSqueakPlatform methodsFor: 'file library' stamp: 'JohnMcKeon 12/27/2014 11:04'!
localNameOf: aFilename
	^FileDirectory localNameFor: aFilename! !

!GRSqueakPlatform methodsFor: 'file library' stamp: 'JohnMcKeon 12/26/2014 19:35'!
pathSeparator
	^ FileDirectory pathNameDelimiter asString! !

!GRSqueakPlatform methodsFor: 'file library' stamp: 'JohnMcKeon 12/26/2014 19:36'!
write: aStringOrByteArray toFile: aFileNameString inFolder: aFolderString
	"writes aStringOrByteArray to a file named aFilenameString in the folder aFolderString"
	| folder stream fullFilePath |
	folder := FileDirectory default directoryNamed: aFolderString.
	fullFilePath := folder fullNameFor: aFileNameString.
	stream := aStringOrByteArray isString
		ifTrue: [		
			(MultiByteFileStream forceNewFileNamed: fullFilePath)
				ascii;
				wantsLineEndConversion: true;
				yourself ]
		ifFalse: [ (FileStream forceNewFileNamed: fullFilePath) binary ].
	[ stream nextPutAll: aStringOrByteArray ]
		ensure: [ stream close ]! !
